<?php defined("SYSPATH") or die("No direct script access.");

class stadfed_Core {

  protected static $exif_keys;

  static function settandd($item) {
    $keys = array();
    // Only try to extract EXIF from photos
    if ($item->is_photo() && $item->mime_type == "image/jpeg") {
      $data = array();
      require_once(MODPATH . "exif/lib/exif.php");
      $exif_raw = read_exif_data_raw($item->file_path(), false);
      if (isset($exif_raw['ValidEXIFData'])) {
        foreach(self::_keys() as $field => $exifvar) {
          if (isset($exif_raw[$exifvar[0]][$exifvar[1]])) {
            $value = $exif_raw[$exifvar[0]][$exifvar[1]];
            $value = encoding::convert_to_utf8($value);
            $keys[$field] = Input::clean($value);
            if ($field == "DateTime") {
              $time = strtotime($value);
              if ($time > 0) {
		if(empty($item->captured)){
		  $item->captured = $time;
		}
	      }
	    } else if ($field == "Caption") {
	      if(empty($item->description)){
		$item->description = $value;
	      }
	    }
	  }
	}
      }

      $size = getimagesize($item->file_path(), $info);
      if (is_array($info) && !empty($info["APP13"])) {
        $iptc = iptcparse($info["APP13"]);
        foreach (array("Keywords" => "2#025", "Caption" => "2#120", "ObjectName" => "2#005") as $keyword => $iptc_key) {
          if (!empty($iptc[$iptc_key])) {
            $value = implode(" ", $iptc[$iptc_key]);
            $value = encoding::convert_to_utf8($value);
            $keys[$keyword] = Input::clean($value);
            if ($keyword == "Caption") {
	      if(empty($item->description)){
		$item->description = $value;
	      }
	    }
	    if ($keyword == "ObjectName") {
		$item->title = $value;
	    }
	    if(empty($item->name)){
	      $item->name = $value;
	    }
	  }
	}
      }
      $item->save();
    }
    if($item->is_movie()){
      $ffmpeg = movie::find_ffmpeg();
      if(empty($ffmpeg)) return;
      $cmd = escapeshellcmd($ffmpeg) . " -i \"" . $item->file_path() . "\"";
      ob_start();
      passthru($cmd . " 2>&1");
      $output = ob_get_contents();
      ob_end_clean();
      if(!empty($output)){
	$output = preg_split("/\n/",$output);
	foreach($output as $line){
	  if(preg_match("/synopsis (.*)/",$line, $match)){
	    $desc = preg_split("/: /",$match[1]);
	  }
	  if(preg_match("/description (.*)/",$line, $match)){
	    $desc = preg_split("/: /",$match[1]);
	  }
	  if(preg_match("/creation_time (.*)/",$line, $match)){
	    $time = preg_split("/: /",$match[1]);
	  }
	  if(preg_match("/title (.*)/",$line, $match)){
	    $title = preg_split("/: /",$match[1]);
	  }
	}
	$yes = 0;
	if(!empty($desc[1])){
	  if(empty($item->description)){
	    $item->description = $desc[1]; 
	    $yes = 1;
	  }
	}
	if(!empty($time[1])){
	  $stime = strtotime($time[1]);
	  if(empty($item->captured)){
	    $item->captured = $stime;
	    $yes = 1;
	  }
	}
	if(!empty($title[1])){
	  if(empty($item->title)){
	    $item->title = $title[1];
	    $yes = 1;
	  }
	  if(empty($item->name)){
	    $item->name = $title[1];
	    $yes = 1;
	  }
	}
	if($yes == 1){
	  $item->save();
	  unset($yes);
	}
      }
    }
  }

  private static function _keys() {
    if (!isset(self::$exif_keys)) {
      self::$exif_keys = array(
        "Make"            => array("IFD0",   "Make",              t("Camera Maker"),     ),
        "Model"           => array("IFD0",   "Model",             t("Camera Model"),     ),
        "Object Name"     => array("IPTC",   "Object Names",      t("Object Name"),     ),
        "Aperture"        => array("SubIFD", "FNumber",           t("Aperture"),         ),
        "ColorSpace"      => array("SubIFD", "ColorSpace",        t("Color Space"),      ),
        "ExposureBias"    => array("SubIFD", "ExposureBiasValue", t("Exposure Value"),   ),
        "ExposureProgram" => array("SubIFD", "ExposureProgram",   t("Exposure Program"), ),
        "ExposureTime"    => array("SubIFD", "ExposureTime",      t("Exposure Time"),    ),
        "Flash"           => array("SubIFD", "Flash",             t("Flash"),            ),
        "FocalLength"     => array("SubIFD", "FocalLength",       t("Focal Length"),     ),
        "ISO"             => array("SubIFD", "ISOSpeedRatings",   t("ISO"),              ),
        "MeteringMode"    => array("SubIFD", "MeteringMode",      t("Metering Mode"),    ),
        "DateTime"        => array("SubIFD", "DateTimeOriginal",  t("Date/Time"),        ),
        "Copyright"       => array("IFD0",   "Copyright",         t("Copyright"),        ),
        "ImageType"       => array("IFD0",   "ImageType",         t("Image Type"),       ),
        "Orientation"     => array("IFD0",   "Orientation",       t("Orientation"),      ),
        "ResolutionUnit"  => array("IFD0",   "ResolutionUnit",    t("Resolution Unit"),  ),
        "xResolution"     => array("IFD0",   "xResolution",       t("X Resolution"),     ),
        "yResolution"     => array("IFD0",   "yResolution",       t("Y Resolution"),     ),
        "Compression"     => array("IFD1",   "Compression",       t("Compression"),      ),
        "BrightnessValue" => array("SubIFD", "BrightnessValue",   t("Brightness Value"), ),
        "Contrast"        => array("SubIFD", "Contrast",          t("Contrast"),         ),
        "ExposureMode"    => array("SubIFD", "ExposureMode",      t("Exposure Mode"),    ),
        "FlashEnergy"     => array("SubIFD", "FlashEnergy",       t("Flash Energy"),     ),
        "Saturation"      => array("SubIFD", "Saturation",        t("Saturation"),       ),
        "SceneType"       => array("SubIFD", "SceneType",         t("Scene Type"),       ),
        "Sharpness"       => array("SubIFD", "Sharpness",         t("Sharpness"),        ),
        "SubjectDistance" => array("SubIFD", "SubjectDistance",   t("Subject Distance"), ),
        "Caption"         => array("IPTC",   "Caption",           t("Caption"),          ),
        "ObjectName"      => array("IPTC",   "ObjectName",        t("ObjectName"),       ),
        "Keywords"        => array("IPTC",   "Keywords",          t("Keywords"),         )
      );
    }
    return self::$exif_keys;
  }
}
